/*******************************************************************************
*  skST7735x - ST7735`bvTFT-LCDp֐Cu                           *
*              ST7735R/S`bv(ΐF^u)̂݊mF                     *
*                                                                              *
*    LCD_begin            - fBXvCW[̏s           *
*    LCD_DisplayDirection - fBXvC̕\w肷鏈               *
*    LCD_CLS              - fBXvC̕\NA鏈                 *
*    LCD_ColorSet         - F̐ݒs                                 *
*    LCD_ReduceColorSet   - RGBl(24rbgF)̌FsFݒ肷鏈  *
*    LCD_PutPixel         - Phbg_`悷鏈                           *
*    LCD_Circle           - w̉~`悷鏈                             *
*    LCD_FillCircle       - w̉~GAwFœhԂ             *
*    LCD_Line             - w̐`悷鏈                             *
*    LCD_Box              - w̎lp``悷鏈                         *
*    LCD_FillBox          - w̎lp`GAwFœhԂ         *
*    LCD_Putc             - w肳ꂽʒuɂP(5x8)`悳鏈          *
*    LCD_Puts             - w肳ꂽʒuɕ(5x8)`悳鏈        *
*    LCD_Putc2x           - w肳ꂽʒuɂQ{̂P(5x8x2)`悳鏈  *
*    LCD_Puts2x           - w肳ꂽʒuɂQ{̕(5x8x2)`悳鏈*
*    LCD_SleepCtl         - X[vON/OFFs                         *
*    LCD_DisplayINV       - fBXvC̔]\؂ւ鏈             *
*                                                                              *
*    F__delay_us() and __delay_ms() gpĂ̂ "skST7735x.h"    *
*         "#define _XTAL_FREQ 32000000""#define FCY 60000000"LqĂ*
*         32MHzȊOCPUNbNɂl͏܂傤B                   *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2019-05-15  ޒH[     Create                                 *
* ============================================================================ *
*  PIC 24EP256MC202 24FJ64GB002 18F26K22                                       *
*  MPLAB X(v5.15)                                                              *
*  MPLAB(R) XC8  C Compiler Version 1.40                                       *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <xc.h>
#include "skSPIlib.h"
#include "skST7735x.h"
#include "font.h"        // 5x8̃LN^[f[^pt@C


uint8_t  DSP_Info ;      // `bvƃfBXvC̏
uint16_t X_Start ;       // t[̗Jnʒu
uint16_t X_End   ;       // t[̗Iʒu
uint16_t Y_Start ;       // t[̍sJnʒu
uint16_t Y_End   ;       // t[̍sIʒu
uint8_t  ColorInfo ;     // F̃rbg
uint8_t  RGB[3] ;        // RGBlST7735̐Fɕϊe[u

/*******************************************************************************
*  LCD_begin(dspinfo,value)                                                    *
*    fBXvCW[̏s                                  *
*    ŐݒsĂȂ@\̓ftHggp܂B                    *
*    dspinfo : kbcW[̏w肵܂                              *
*              ݂́A"CHIP_ST7735X|DISPLAY_TYPE_1"݂̂pӂĂ܂ *
*    value   : ʂ̏Fw  0=  1=                                    *
*******************************************************************************/
void LCD_begin(uint8_t dspinfo,uint8_t value)
{
     DSP_Info = dspinfo ;
     RGB[0] = RGB[1] = RGB[2] = 0 ;

     TFT_CS = 1 ;
     __delay_ms(100) ;
     // fBXvCW[̏(ݒ肵ĂȂ@\̓ftHggp)
     LCD_SendByte(ST7735X_CMD_SWREST,ST7735X_COMMAND) ; // \tgEFAZbgR}h̔s
	__delay_ms(120) ;
     LCD_SendByte(ST7735X_CMD_SLPOUT,ST7735X_COMMAND) ; // X[v畜AR}h̔s
     __delay_ms(120) ;

     // yO[^uz(fBXvC͉ɐݒ)
     if (DSP_Info == (CHIP_ST7735X | DISPLAY_TYPE_1)) {
          // F̊Kw肷R}h̔s(18rbgJ[w)
          ColorInfo = ST7735X_PARA_18COLOR ;
          LCD_SendByte(ST7735X_CMD_COLMOD,ST7735X_COMMAND) ;
          LCD_SendByte(ColorInfo,ST7735X_PARAMETER) ;
          // fBXvC̕\w肷鏈
          // tLVuP[u͍()
          LCD_DisplayDirection(4) ;
     }

     LCD_SendByte(ST7735X_CMD_DISPON,ST7735X_COMMAND) ; // fBXvC\R}h̔s
     __delay_ms(100) ;
     LCD_CLS(value) ;                                   // ʂorŏ
}
/*******************************************************************************
*  LCD_SendByte(value,dc)                                                      *
*    fBXvCW[1oCg̃f[^𑗐M鏈                     *
*    value : Mf[^                                                    *
*    dc    : Mf[^̎(0=R}h 1=p[^)                     *
*******************************************************************************/
void LCD_SendByte(uint8_t value, uint8_t dc)
{
     TFT_CS = 0 ;
     TFT_DC = dc ;
     SPI_transfer(value) ;
     TFT_CS = 1 ;
}
/*******************************************************************************
*  LCD_SendWord(value)                                                         *
*    fBXvCW[2oCg̃p[^𑗐M鏈                 *
*    value : Mf[^                                                    *
*******************************************************************************/
void LCD_SendWord(uint16_t value)
{
     TFT_CS = 0 ;
     TFT_DC = 1 ;
     SPI_transfer((uint8_t)((value >> 8) & 0x00FF)) ;
     SPI_transfer((uint8_t)(value & 0x00FF)) ;
     TFT_CS = 1 ;
}
/*******************************************************************************
*  LCD_DisplayInit()                                                           *
*    fBXvC͈̔(\f)ݒ肷鏈                              *
*    gpfBXvCɉĒǋL܂傤B                              *
*    DisplayDirection()gƏcւ܂                        *
*******************************************************************************/
void LCD_DisplayInit()
{
     // yO[^uz(fBXvC͏cɐݒ)
     if (DSP_Info == (CHIP_ST7735X | DISPLAY_TYPE_1)) {
          // fBXvC̕\f 128x160()
          X_Start = 0 ;
          X_End   = DISPLAY_COLUMN128 - 1 ;
          Y_Start = 0 ;
          Y_End   = DISPLAY_ROW160 - 1 ;
     }
}
/*******************************************************************************
*  LCD_DisplayDirection(value)                                                 *
*    fBXvC̕\w肷鏈                                      *
*    value : \w(1-4)                                               *
*******************************************************************************/
void LCD_DisplayDirection(uint8_t value)
{
     uint16_t xe , ye ;

     LCD_DisplayInit() ;      // fBXvC͈̔(\f)ݒ肷

     LCD_SendByte(ST7735X_CMD_MADCTL,ST7735X_COMMAND) ;
     switch(value) {
        case 1: // tLVuP[uŁAオ0.0()
               LCD_SendByte(0x00,ST7735X_PARAMETER) ;
               break ;
        case 2: // tLVuP[uŁAオ0.0
               LCD_SendByte(0xC0,ST7735X_PARAMETER) ;
               break ;
        case 3: // tLVuP[uEŁAオ0.0
               LCD_SendByte(0xA0,ST7735X_PARAMETER) ;
               xe = X_End ;
               ye = Y_End ;
               X_End   = ye ;
               Y_End   = xe ;
               break ;
        case 4: // tLVuP[uŁAオ0.0
               LCD_SendByte(0x60,ST7735X_PARAMETER) ;
               xe = X_End ;
               ye = Y_End ;
               X_End   = ye ;
               Y_End   = xe ;
               break ;
     }
}
/*******************************************************************************
*  ans = LCD_RangSET(xs,xe,ys,ye)                                              *
*    ރt[͈̔͂w肷鏈                                *
*    ޏꍇ(\ꍇ)́AKꏊw肷KvL܂B          *
*    xs  : 񑤊Jnʒu                                                        *
*    xe  : 񑤏Iʒu                                                        *
*    ys  : sJnʒu                                                        *
*    ye  : sIʒu                                                        *
*    ans : 0=ɐݒ肵  1=w肪͈͊O                                    *
*******************************************************************************/
uint8_t LCD_RangSET(uint16_t xs, uint16_t xe, uint16_t ys, uint16_t ye)
{
     uint8_t ans ;
     uint16_t x , y ;

     ans = 0 ;
     x = X_End - X_Start ;
     y = Y_End - Y_Start ;
     if ((xs <= x) && (xe <= x) && (ys <= y) && (ye <= y)) {
          // ރt[̗񑤔͈͂w肷
          LCD_SendByte(ST7735X_CMD_CASET,ST7735X_COMMAND) ;
          LCD_SendWord(X_Start+xs) ;     // Jn
          LCD_SendWord(X_Start+xe) ;     // I
          // ރt[̍s͈͂w肷
          LCD_SendByte(ST7735X_CMD_RASET,ST7735X_COMMAND) ;
          LCD_SendWord(Y_Start+ys) ;     // Jns
          LCD_SendWord(Y_Start+ye) ;     // Is
     } else ans = 1 ;
     return ans ;
}
/*******************************************************************************
*  LCD_CLS(value)                                                              *
*    fBXvC̕\NA鏈                                        *
*    ̏́Ał̂ݓhԂ܂AFtꍇFillBoxgpB *
*    value : 0=  1=                                                        *
*******************************************************************************/
void LCD_CLS(uint8_t value)
{
     uint8_t  c ;
     uint16_t x , i ;

     // ރt[͈̔͂w
     LCD_RangSET(X_Start,X_End,Y_Start,Y_End) ;
     // ͈͓f[^ɏ
     if (value == 0) c = 0x00 ;
     else {
          if (ColorInfo == ST7735X_PARA_18COLOR) c = 0xFC ;
          else                                   c = 0xFF ;
     }
     x = ((X_End - X_Start) + 1) * ((Y_End - Y_Start) + 1) ;
     LCD_SendByte(ST7735X_CMD_RAMWR,ST7735X_COMMAND) ;
     for (i=0 ; i<x ; i++) {
          LCD_SendByte(c,ST7735X_PARAMETER) ;
          LCD_SendByte(c,ST7735X_PARAMETER) ;
          LCD_SendByte(c,ST7735X_PARAMETER) ;
     }
}
/*******************************************************************************
*  LCD_ColorSet(red,green,blue)                                                *
*    F̐ݒs                                                        *
*    ̏́Aw肳ꂽRGBST7735p̐F\ɕϊ܂A                 *
*    A12/16/18rbgJ[̂ݑΉĂ܂Ȃ͍ɐݒ肳܂B    *
*    12bit(R:4 G:4 B:4)  16bit(R:5 G:6 B:5)  18bit(R:6 G:6 B:6)                *
*    red   : RGBŎw̐                                                     *
*    green : RGBŎw̗                                                     *
*    blue  : RGBŎw̐                                                     *
*******************************************************************************/
void LCD_ColorSet(uint8_t red, uint8_t green, uint8_t blue)
{
     switch (ColorInfo) {
       case ST7735X_PARA_18COLOR:
            if ((red < 64) && (green < 64) && (blue < 64)) {
                 RGB[0] = red << 2 ;
                 RGB[1] = green << 2 ;
                 RGB[2] = blue << 2 ;
            }
            break ;
       case ST7735X_PARA_16COLOR:
            if ((red < 32) && (green < 64) && (blue < 32)) {
                 RGB[0] = (red << 3) | ((green & 0x38)>>3) ;
                 RGB[1] = ((green & 0x07) << 5) | blue ;
                 RGB[2] = 0 ;
            }
            break ;
       case ST7735X_PARA_12COLOR:
            if ((red < 16) && (green < 16) && (blue < 16)) {
                 RGB[0] = (red << 4) | (green & 0x0F) ;
                 RGB[1] = blue << 4 ;
                 RGB[2] = 0 ;
            }
            break ;
       default:
            RGB[0] = RGB[1] = RGB[2] = 0 ;
            break ;
     }
}
/*******************************************************************************
*  LCD_ReduceColorSet(red,green,blue)                                          *
*    RGBl(24rbgF)̌FsFݒ肷鏈                         *
*    16rbgF́AR(5):G(6):B(5)rbgG(5)ɓꂷ                      *
*    red   : RGBŎw(24rbg)̐                                           *
*    green : RGBŎw(24rbg)̗                                           *
*    blue  : RGBŎw(24rbg)̐                                           *
*******************************************************************************/
void LCD_ReduceColorSet(uint8_t red, uint8_t green, uint8_t blue)
{
     uint8_t c ;

     // FF`FbN
     if (ColorInfo == ST7735X_PARA_12COLOR) c = ColorInfo + 1 ;
     else c = ColorInfo ;
     c = 8 - c ;
     // Fݒ肷
     LCD_ColorSet(red >> c, green >> c, blue >> c) ;
}
/*******************************************************************************
*  LCD_PutPixel(xp,yp)                                                         *
*    Phbg_`悷鏈                                                  *
*    xp : fBXvCW̗()ʒu                                         *
*    yp : fBXvCW̍s(c)ʒu                                         *
*******************************************************************************/
void LCD_PutPixel(uint16_t xp, uint16_t yp)
{
     uint8_t ans;

     // ރt[͈̔͂w
     ans = LCD_RangSET(xp,xp,yp,yp) ;
     if (ans == 0) {
          // w̃t[ꏊɐFf[^
          LCD_SendByte(ST7735X_CMD_RAMWR,ST7735X_COMMAND) ;
          LCD_SendByte(RGB[0],ST7735X_PARAMETER) ;
          LCD_SendByte(RGB[1],ST7735X_PARAMETER) ;
          LCD_SendByte(RGB[2],ST7735X_PARAMETER) ;
     }
}
/*******************************************************************************
*  LCD_Circle(xp,yp,radius)                                                    *
*    w̉~`悷鏈                                                    *
*    xp     : fBXvCW̗()ʒu                                     *
*    yp     : fBXvCW̍s(c)ʒu                                     *
*    radius : xp/yp𒆐SƂāA̔aw肵܂                    *
*******************************************************************************/
void LCD_Circle(uint16_t xp, uint16_t yp, uint16_t radius)
{
    int16_t f     = 1 - radius ;
    int16_t ddF_x = 1 ;
    int16_t ddF_y = -2 * radius ;
    int16_t x     = 0 ;
    int16_t y     = radius ;

    LCD_PutPixel(xp  , yp+radius) ;
    LCD_PutPixel(xp  , yp-radius) ;
    LCD_PutPixel(xp+radius, yp) ;
    LCD_PutPixel(xp-radius, yp) ;

    while (x < y) {
        if (f >= 0) {
            y-- ;
            ddF_y += 2 ;
            f += ddF_y ;
        }
        x++ ;
        ddF_x += 2 ;
        f += ddF_x ;
        LCD_PutPixel(xp + x, yp + y) ;
        LCD_PutPixel(xp - x, yp + y) ;
        LCD_PutPixel(xp + x, yp - y) ;
        LCD_PutPixel(xp - x, yp - y) ;
        LCD_PutPixel(xp + y, yp + x) ;
        LCD_PutPixel(xp - y, yp + x) ;
        LCD_PutPixel(xp + y, yp - x) ;
        LCD_PutPixel(xp - y, yp - x) ;
    }
}
/*******************************************************************************
*  LCD_FillCircle(xp,yp,radius)                                                *
*    w̉~GAwFœhԂ                                    *
*    ύXΑȉ~\łAA_gȂƃ_łB    *
*    xp     : fBXvCW̗()ʒu                                     *
*    yp     : fBXvCW̍s(c)ʒu                                     *
*    radius : xp/yp𒆐SƂāA̔aw肵܂                    *
*******************************************************************************/
void LCD_FillCircle(uint16_t xp, uint16_t yp, uint16_t radius)
{
     int16_t iyp1,ixp1,iyp2,ixp2 ;
     int16_t ix,iy,x,y,r,y1 ;

     // lp`GA̒SN_ɂĔa(radius)̉~hԂ܂
     r = radius * radius ;
     ixp1 = xp * 2 ; ixp2 = ixp1 / 2 ;
     iyp1 = yp * 2 ; iyp2 = iyp1 / 2 ;
     for (iy = 0 ; iy < iyp1 ; iy++) {
          y  = iy - iyp2 ;         // "y/W"ŉȉ~ɂȂAW0.0-1.0
          y1 = y * y ;
          for(ix = 0 ; ix < ixp1 ; ix++) {
               x = ix - ixp2 ;     // "x/W"ŏcȉ~ɂȂAW0.0-1.0
               if ( (x * x) + y1 < r) {
                    // ~̓ȂPhbg`
                    LCD_PutPixel(ix, iy) ;
               }
          }
     }
}
/*******************************************************************************
*  LCD_Line(xsp,ysp,xep,yep)                                                   *
*    w̐`悷鏈                                                    *
*    xsp/yspJn_ƂāAxep/yepI_ƂΊpɐ`܂B      *
*    xsp : fBXvCW̊Jn()ʒu                                *
*    ysp : fBXvCW̊Jns(c)ʒu                                *
*    xep : fBXvCW̏I()ʒu                                *
*    yep : fBXvCW̏Is(c)ʒu                                *
*******************************************************************************/
void LCD_Line(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep)
{
     int steep ;
     int deltax, deltay, er ;
     int x, y;
     int ystep;
	
     /// ̑傫ق߂
     steep = (abs(yep - ysp) > abs(xep - xsp)) ;
     /// A̓ւ
     if (steep){
          x = xsp; xsp = ysp; ysp = x ;
          x = xep; xep = yep; yep = x ;
     }
     if (xsp > xep) {
          x = xsp; xsp = xep; xep = x ;
          x = ysp; ysp = yep; yep = x ;
     }
     deltax = xep - xsp ;		// XvZ
     deltay = abs(yep - ysp) ;
     er = 0 ;
     y  = ysp ;
     /// XŃXebv̐؂ւ
     if (ysp < yep) ystep = 1 ; 
     else           ystep = -1 ;
     /// _ŕ`
     for (x=xsp ; x <= xep ; x++) {
          if (steep) LCD_PutPixel(y,x) ; 
          else       LCD_PutPixel(x,y) ;
          er += deltay ;
          if((er << 1) >= deltax) {
               y  += ystep ;
               er -= deltax ;
          }
     }
}
/*******************************************************************************
*  LCD_Box(xsp,ysp,xep,yep)                                                    *
*    w̎lp``悷鏈                                                *
*    xsp/yspJn̒_ƂāAxep/yepI̒_Ƃlp``܂B    *
*    xsp : fBXvCW̊Jn()ʒu                                *
*    ysp : fBXvCW̊Jns(c)ʒu                                *
*    xep : fBXvCW̏I()ʒu                                *
*    yep : fBXvCW̏Is(c)ʒu                                *
*******************************************************************************/
void LCD_Box(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep)
{
     int i ;

     for (i=xsp ; i <= xep ; i++) {
          LCD_PutPixel(i,ysp) ;    // 㑤
          LCD_PutPixel(i,yep) ;    // 
     }
     for (i=ysp+1 ; i <= yep ; i++) {
          LCD_PutPixel(xsp,i) ;    // c
          LCD_PutPixel(xep,i) ;    // Ec
     }
}
/*******************************************************************************
*  LCD_FillBox(xsp,ysp,xep,yep)                                                *
*    w̎lp`GAwFœhԂ                                *
*    xsp/yspJn̒_ƂāAxep/yepI̒_Ƃlp`hԂ܂*
*    xsp : fBXvCW̊Jn()ʒu                                *
*    ysp : fBXvCW̊Jns(c)ʒu                                *
*    xep : fBXvCW̏I()ʒu                                *
*    yep : fBXvCW̏Is(c)ʒu                                *
*******************************************************************************/
void LCD_FillBox(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep)
{
     uint16_t i , j ;

     if ((xep-xsp) > (yep-ysp)) {
          // ꍇ
          for (j=ysp ; j<=yep ; j++) {
               LCD_RangSET(xsp,xep,j,j) ;
               LCD_SendByte(ST7735X_CMD_RAMWR,ST7735X_COMMAND) ;
               for (i=xsp ; i<=xep ; i++) {
                    LCD_SendByte(RGB[0],ST7735X_PARAMETER) ;
                    LCD_SendByte(RGB[1],ST7735X_PARAMETER) ;
                    LCD_SendByte(RGB[2],ST7735X_PARAMETER) ;
               }
          }
     } else {
          // cꍇ
          for (j=xsp ; j<=xep ; j++) {
               LCD_RangSET(j,j,ysp,yep) ;
               LCD_SendByte(ST7735X_CMD_RAMWR,ST7735X_COMMAND) ;
               for (i=ysp ; i<=yep ; i++) {
                    LCD_SendByte(RGB[0],ST7735X_PARAMETER) ;
                    LCD_SendByte(RGB[1],ST7735X_PARAMETER) ;
                    LCD_SendByte(RGB[2],ST7735X_PARAMETER) ;
               }
          }
     }
}
/*******************************************************************************
*  LCD_Putc(xc,yc,c)                                                           *
*    w肳ꂽʒuɂP(5x8)`悳鏈                                 *
*    ۂ̕5x7hbgŁA8hbgڂ̓Xy[XłB                    *
*    xp : fBXvCW̗()ʒu                                         *
*    yp : fBXvCW̍s(c)ʒu                                         *
*    c  : \1w肵܂                                            *
*******************************************************************************/
void LCD_Putc(uint16_t xp, uint16_t yp, uint8_t c)
{
     uint8_t  i , j , f ;
     uint16_t x , y  ;

     for (i=0 ; i<5 ; i++) {
          x = i + xp ;
          f = Font[c-0x20][i] ;
          for (j=0 ; j<8 ; j++) {
               y = j + yp ;
               if (((f >> j) & 0x01) == 1) LCD_PutPixel(x,y) ;
          }
     }
}
/*******************************************************************************
*  LCD_Puts(xc,yc,*s)                                                          *
*    w肳ꂽʒuɕ(5x8)`悳鏈                               *
*    xp : fBXvCW̗()ʒu                                         *
*    yp : fBXvCW̍s(c)ʒu                                         *
*    *s : \镶w肵܂(̍ŌnullłȂ΂Ȃ܂)   *
*******************************************************************************/
void LCD_Puts(uint16_t xp, uint16_t yp, const char *s)
{
     while(*s) {
          LCD_Putc(xp,yp,*s++) ;
          xp = xp + 6 ;       // 1hbg󂯂ׂ5+1=6Ƃ
     }
}
/*******************************************************************************
*  LCD_Putc2x(xc,yc,c)                                                         *
*    w肳ꂽʒuɂQ{̂P(5x8x2)`悳鏈                         *
*    xp : fBXvCW̗()ʒu                                         *
*    yp : fBXvCW̍s(c)ʒu                                         *
*    c  : \1w肵܂                                            *
*******************************************************************************/
void LCD_Putc2x(uint16_t xp, uint16_t yp, uint8_t c)
{
     uint8_t  i , j , f ;
     uint16_t x , y , x1 , y1 ;

     for (i=0 ; i<5 ; i++) {
          x = ((i*2) + xp) ;
          x1 = x + 1 ;
          f = Font[c-0x20][i] ;
          for (j=0 ; j<8; j++) {
               y = ((j*2) + yp) ;
               y1 = y + 1 ;
               if (((f >> j) & 0x01) == 1) {
                    LCD_PutPixel(x,y) ;
                    LCD_PutPixel(x1,y) ;
                    LCD_PutPixel(x,y1) ;
                    LCD_PutPixel(x1,y1) ;
               }
          }
     }
}
/*******************************************************************************
*  LCD_Puts2x(xc,yc,*s)                                                        *
*    w肳ꂽʒuɂQ{̕(5x8x2)`悳鏈                       *
*    xp : fBXvCW̗()ʒu                                         *
*    yp : fBXvCW̍s(c)ʒu                                         *
*    *s : \镶w肵܂(̍ŌnullłȂ΂Ȃ܂)   *
*******************************************************************************/
void LCD_Puts2x(uint16_t xp, uint16_t yp, const char *s)
{
     while(*s) {
          LCD_Putc2x(xp++,yp,*s++) ;
          xp = xp + 11 ;      // 1hbg󂯂ׂ5+5+1=11Ƃ
     }
}
/*******************************************************************************
*  LCD_SleepCtl(sel)                                                           *
*    X[vON/OFFs                                                *
*    A΂̑O܂ł̉ʂ\܂AX[vɉʕ\OFF *
*    obNCg͏ȂA킩ȂB                              *
*    sel : 0= X[v̕A  1= X[v[hɂ                      *
*******************************************************************************/
void LCD_SleepCtl(uint8_t sel)
{
     if (sel == 0) {
          LCD_SendByte(ST7735X_CMD_SLPOUT,ST7735X_COMMAND) ;     // X[v畜A
          __delay_ms(120) ;
          LCD_SendByte(ST7735X_CMD_DISPON,ST7735X_COMMAND) ;     // ʕ\nm 
          __delay_ms(100) ;
     } else {
          LCD_SendByte(ST7735X_CMD_DISPOFF,ST7735X_COMMAND) ;    // ʕ\nee
          LCD_SendByte(ST7735X_CMD_SLPIN,ST7735X_COMMAND) ;      // X[vs
          __delay_ms(120) ;
     }
}
/*******************************************************************************
*  LCD_DisplayINV(sel)                                                         *
*    fBXvC̔]\؂ւ鏈                                    *
*    ̏s_Ńt[S(ʑS)rbg]ĕ\    *
*    ܂AFꍇ͍ŕ\܂B                          *
*    sel : 0= ]\nee  1= ]\nm                                  *
*******************************************************************************/
void LCD_DisplayINV(uint8_t sel)
{
     if (sel == 0) {
          LCD_SendByte(ST7735X_CMD_INVOFF,ST7735X_COMMAND) ;// ]\neeR}h̔s
     } else {
          LCD_SendByte(ST7735X_CMD_INVON,ST7735X_COMMAND) ; // ]\nmR}h̔s
     }
}
